// flagOnSpawn.cpp : Defines the entry point for the DLL application.
//

#include "bzfsAPI.h"
#include <string>

BZ_GET_PLUGIN_VERSION

class FlagOnSpawnHandler : public bz_EventHandler {
public:
	virtual void process( bz_EventData *eventData );

	std::string flagTypes[5];
	std::string flagDescriptions[5];
	short team;
};

FlagOnSpawnHandler flagOnSpawnHandler;

BZF_PLUGIN_CALL int bz_Load ( const char* orig_arg_str )
{
	bz_debugMessage(4,"flagOnSpawn plugin loaded");
	bz_registerEvent( bz_ePlayerSpawnEvent, &flagOnSpawnHandler );

	std::string arg_str = orig_arg_str;
	bool initFailed = false;
	int numArgs = 0;

	if( arg_str[0] != '\0' ) {
		// Arguments given; process them
		char args[10][3] = { };
		int counter = 0;
		int origArrayCounter = 0;
		int myArrayCounter = 0;

		while( counter < 10 &&
				counter < (int) strlen( arg_str.c_str() ) &&
							myArrayCounter < 2 ) {
			while( arg_str[origArrayCounter] != ':' &&
					arg_str[origArrayCounter] != '\0' ) {
				args[counter][myArrayCounter] =
						arg_str[origArrayCounter];
				++origArrayCounter;
				++myArrayCounter;
			}

			args[counter][myArrayCounter] = '\0';
			myArrayCounter = 0;

			++counter;

			if( arg_str[origArrayCounter] == '\0' ) break;
			++origArrayCounter;
		}

		numArgs = counter;

		counter = 1;
		while( counter < numArgs && args[counter] != '\0' ) {
			int testvalue;
		( args[counter][0] == '-' && args[counter][1] == '1' ) ?
		testvalue = -1 : testvalue = args[counter][0] - '0';
			if( testvalue > 4 || testvalue < -2 ) {
				// FAIL HERE
				initFailed = true;
			}

			counter += 2;
		}

		counter = 1;
		while( counter < numArgs && args[counter - 1] != '\0' ) {
			if( args[counter][0] == '-'
						&& args[counter][1] == '1' ) {
				int teamCounter = 0;

				while( teamCounter < 5 ) {
					flagOnSpawnHandler.flagTypes[
					teamCounter] = args[counter - 1];
					teamCounter++;
				}

				break;
			}

			counter += 2;
		}

		counter = 1;
		while( counter < numArgs && counter < numArgs ) {
				if( args[counter][0] != '-' ) {
		flagOnSpawnHandler.flagTypes[ (int) (args[counter][0]- '0') ] =
					args[(counter - 1)];
			}

			counter += 2;
		}
	} else {
		// No arguments; FAIL HERE
		initFailed = true;
	}

	int counter = 0;
	while( counter < 5 ) {
	if( flagOnSpawnHandler.flagTypes[counter] != "" ) {
		if( flagOnSpawnHandler.flagTypes[counter] == "A" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Agility";
		else if( flagOnSpawnHandler.flagTypes[counter] == "B" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Blindness";
		else if( flagOnSpawnHandler.flagTypes[counter] == "B*" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Blue Team";
		else if( flagOnSpawnHandler.flagTypes[counter] == "BU" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Burrow";
		else if( flagOnSpawnHandler.flagTypes[counter] == "BY" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Bouncy";
		else if( flagOnSpawnHandler.flagTypes[counter] == "CB" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Colorblindness";
		else if( flagOnSpawnHandler.flagTypes[counter] == "CL" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Cloaking";
		else if( flagOnSpawnHandler.flagTypes[counter] == "F" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Rapid Fire";
		else if( flagOnSpawnHandler.flagTypes[counter] == "FO" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Forward Only";
		else if( flagOnSpawnHandler.flagTypes[counter] == "G" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Genocide";
		else if( flagOnSpawnHandler.flagTypes[counter] == "G*" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Green Team";
		else if( flagOnSpawnHandler.flagTypes[counter] == "GM" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Guided Missile";
		else if( flagOnSpawnHandler.flagTypes[counter] == "IB" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Invisible Bullet";
		else if( flagOnSpawnHandler.flagTypes[counter] == "ID" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Identify";
		else if( flagOnSpawnHandler.flagTypes[counter] == "JM" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Jamming";
		else if( flagOnSpawnHandler.flagTypes[counter] == "JP" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Jumping";
		else if( flagOnSpawnHandler.flagTypes[counter] == "L" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Laser";
		else if( flagOnSpawnHandler.flagTypes[counter] == "LT" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Left Turn Only";
		else if( flagOnSpawnHandler.flagTypes[counter] == "M" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Momentum";
		else if( flagOnSpawnHandler.flagTypes[counter] == "MG" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Machine Gun";
		else if( flagOnSpawnHandler.flagTypes[counter] == "MQ" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Masquerade";
		else if( flagOnSpawnHandler.flagTypes[counter] == "N" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Narrow";
		else if( flagOnSpawnHandler.flagTypes[counter] == "NJ" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "No Jumping";
		else if( flagOnSpawnHandler.flagTypes[counter] == "O" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Obesity";
		else if( flagOnSpawnHandler.flagTypes[counter] == "OO" )
			flagOnSpawnHandler.flagDescriptions[counter]
						= "Oscillation Overthruster";
		else if( flagOnSpawnHandler.flagTypes[counter] == "P*" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Purple Team";
		else if( flagOnSpawnHandler.flagTypes[counter] == "PZ" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Phantom Zone";
		else if( flagOnSpawnHandler.flagTypes[counter] == "QT" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Quick Turn";
		else if( flagOnSpawnHandler.flagTypes[counter] == "R" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Ricochet";
		else if( flagOnSpawnHandler.flagTypes[counter] == "R*" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Red Team";
		else if( flagOnSpawnHandler.flagTypes[counter] == "RC" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "ReverseControls";
		else if( flagOnSpawnHandler.flagTypes[counter] == "RO" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "ReverseOnly";
		else if( flagOnSpawnHandler.flagTypes[counter] == "RT" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Right Turn Only";
		else if( flagOnSpawnHandler.flagTypes[counter] == "SB" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Super Bullet";
		else if( flagOnSpawnHandler.flagTypes[counter] == "SE" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Seer";
		else if( flagOnSpawnHandler.flagTypes[counter] == "SH" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Shield";
		else if( flagOnSpawnHandler.flagTypes[counter] == "SR" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Steamroller";
		else if( flagOnSpawnHandler.flagTypes[counter] == "ST" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Stealth";
		else if( flagOnSpawnHandler.flagTypes[counter] == "SW" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Shock Wave";
		else if( flagOnSpawnHandler.flagTypes[counter] == "T" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Tiny";
		else if( flagOnSpawnHandler.flagTypes[counter] == "TH" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Thief";
		else if( flagOnSpawnHandler.flagTypes[counter] == "TR" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Trigger Happy";
		else if( flagOnSpawnHandler.flagTypes[counter] == "US" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Useless";
		else if( flagOnSpawnHandler.flagTypes[counter] == "V" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "High Speed";
		else if( flagOnSpawnHandler.flagTypes[counter] == "WA" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Wide Angle";
		else if( flagOnSpawnHandler.flagTypes[counter] == "WG" )
			flagOnSpawnHandler.flagDescriptions[counter]
							= "Wings";
		else {
			// FAIL HERE
			initFailed = true;
		}
	}

		++counter;
	}

	if( initFailed ) {
		// Problem with arguments somewhere; use default values

		bz_debugMessage(4,"flagOnSpawn: Bad arguments, using defaults." );
		counter = 0;
		while( counter < 5 ) {
			flagOnSpawnHandler.flagTypes[counter] = "WG";
			flagOnSpawnHandler.flagDescriptions[counter] = "Wings";

			++counter;
		}
	}
	return 0;
}

BZF_PLUGIN_CALL int bz_Unload ( void )
{
	bz_removeEvent( bz_ePlayerSpawnEvent, &flagOnSpawnHandler );
	bz_debugMessage(4,"flagOnSpawn plugin unloaded");

	return 0;
}

void FlagOnSpawnHandler::process( bz_EventData *eventData )
{
  bz_PlayerSpawnEventData *spawnData = (bz_PlayerSpawnEventData*) eventData;
  int playerID = spawnData->playerID;

  bz_PlayerRecord *myPlayer = bz_getPlayerByIndex( playerID );
  if (!myPlayer) return;

  int playerTeam = (int) myPlayer->team;	//bz_eTeamType;

  if( flagTypes[playerTeam].c_str() != '\0' ) {
    if( bz_givePlayerFlag( playerID,
			   flagTypes[playerTeam].c_str(), false ) ) {
      std::string mesg = "You were given a " +
	flagOnSpawnHandler.flagDescriptions[
					    playerTeam] +
	" flag by the server.";
      bz_sendTextMessage( BZ_SERVER, playerID,
			  mesg.c_str() );
    } else
      bz_debugMessage(4, "flagOnSpawn: A flag could not be given to a player");
  }

  bz_freePlayerRecord( myPlayer );
}
